UNIT QBBS;

INTERFACE

USES DOS;

CONST
  regesteredto                  ='TOPsoftware';
  rx_queue_size               = 128;

VAR
  rx_queue: ARRAY [1..rx_queue_size] OF Byte;
  rx_in   : Word;        {Index of where to store next character}
  rx_out  : Word;        {Index of where to retrieve next character}
  rx_chars: Word;        {Number of chars in queue}


    CONST
       bs                     = ^H;
       cr                     = ^M;
       lf                     = ^J;
       esc                    = #027;
       Tab                    = ^I;
       ucase                  = TRUE;
       echo                   = TRUE;
       noecho                 = FALSE;
       lcase                  = FALSE;
       LogFile                = TRUE;
       NoLogFile              = FALSE;
       show                   = TRUE;
       noshow                 = FALSE;
       breakon                = TRUE;
       breakoff               = FALSE;
       min_space_needed       = 100;
       SoftWareName           = 'TOPquark 1.2 (c) 1993 by TOPsoftware.';
       CompileDate            = 'Compiled 9/08/93';
       ReadHLP_Name           = 'READHLP.TXT';
       Gr_ReadHlp_Name        = 'READHLP.GRA';
       log_file_name          = 'USERLOG.DAT';
       GrLogFile              = 'USERLOG.GRA';
       Config_filename        = 'CONFIG.DAT';
       Boards_file_name       = 'BOARDS.TXT';
       User_Menu_Name         = 'USERMNU.TXT';
       Gr_User_Menu_Name      = 'USERMNU.GRA';
       Main_Menu_name         = 'MAINMNU.TXT';
       Gr_Main_Menu_Name      = 'MAINMNU.GRA';
       Read_Menu_Name         = 'READMNU.TXT';
       Gr_Read_Menu_Name      = 'READMNU.GRA';
       Bye_Name               = 'BYE.TXT';
       Gr_Bye_Name            = 'BYE.GRA';
       Welcome_Name           = 'WELCOME1.TXT';
       Bulletin_Name          = 'WELCOME2.TXT';
       Gr_Bulletin_Name       = 'WELCOME2.GRA';

       max_msgs_possible      = 400;
       max_users_possible     = 300;
       MaxMessageLines        = 80;
       max_boards_possible    = 15;
       header_extension       = '.hdr';
       lib_extension          = '.msg';



    TYPE
       anystring    = STRING [255];
       nametype     = STRING [40];
       charset      = SET OF CHAR;
       block_file   = FILE;
       access_array = ARRAY [0..15] OF BYTE;
       window_type  = (init,
		       violate,
		       Utime,
		       avail,
		       keyb,
		       usrc,
		       yell,
		       busy,
		       SetNewTime,
                       SetNewLevel,
		       MakePerm,
		       Vlevel,
		       UnVlevel,
		       Redraw,
		       DrawMenu,
		       ToggleMenu,
                       Alarm);


    TYPE
       date_type = RECORD
          month     : WORD;
          day       : WORD;
          year      : WORD;
          DayOfWeek : WORD;
       END;

FileAreaRecord = RECORD
          Deleted         : BOOLEAN;
          FileName        : STRING[40];
          NameHash        : LONGINT;
          Description     : ARRAY [1..5] of STRING [80];
          Password        : STRING [10];
          FSize           : REAL;
          TimesDownloaded : LONGINT;
          UploadedBy      : STRING [40];
          Date            : Date_Type;
          BlankInt1       : INTEGER;
          BlankInt2       : INTEGER;
          BlankInt3       : INTEGER;
          BlankStr4       : STRING [80];
          BlankStr5       : STRING [80];
          BlankStr6       : STRING [80];
          BlankBoo7       : BOOLEAN;
          BlankBoo8       : BOOLEAN;
          BlankBoo9       : BOOLEAN;
     END;



       time_type = RECORD
          hour: WORD;
          min : WORD;
          sec : WORD;
       END;

       PhoneType = RECORD
          Area_Code : STRING [3];
          Prefix    : STRING [3];
          Suffix    : STRING [4];
       END;

       board_type = RECORD
          name           : STRING[80];
          path           : STRING[40];
          Tpath          : STRING[40];
          Ipath          : STRING[40];
          filename       : STRING[9];
          max_msgs       : INTEGER;
          messageindex   : ARRAY[1..max_msgs_possible] OF INTEGER;
          new_msg_index  : ARRAY[0..max_msgs_possible] OF INTEGER;
          highest_read   : INTEGER;
          msg_pointer    : INTEGER;
          default_access : CHAR;
          validate_access: CHAR;
          new_since_pack : BYTE;
          new_msg_start  : INTEGER;
          total_msgs     : INTEGER;
          total_deleted  : INTEGER;
          blocks_deleted : INTEGER;
       END;


       UserRecord = RECORD
          Deleted       : BOOLEAN;
          Locked        : BOOLEAN;
          Name          : NameType;
          Alais         : NameType;
          AlaisOn       : BOOLEAN;
          Phone         : PhoneType;
          CityState     : STRING;
          Address       : STRING;
          Level         : BYTE;
          Password      : STRING[8];
          Width         : BYTE;
          Board_Access  : ARRAY[0..15] OF CHAR;
          Highest_Read  : ARRAY[0..15] OF INTEGER;
          Zip_Read      : ARRAY[1..15] OF BOOLEAN;
          UseAlais      : ARRAY[1..15] OF BOOLEAN;
          Up_K          : WORD;
          Dn_K          : WORD;
          TimeLeftToday : INTEGER;
          F_U           : INTEGER;
          F_D           : INTEGER;
          D_Level       : BYTE;
          Month         : BYTE;
          Day           : BYTE;
          Year          : WORD;
          DayOfWeek     : BYTE;
          Hour          : BYTE;
          Min           : BYTE;
          Editor_Exit   : STRING[5];
          Graphics      : BOOLEAN;
          PostTimes     : LONGINT;
          CallTimes     : LONGINT;
          Ratio         : REAL;
          Alarm         : BOOLEAN;
          BytesPosted   : LONGINT;
          MorePrompt    : BOOLEAN;
          ScrnLines     : INTEGER;
          Blank1        : INTEGER;
          Blank2        : INTEGER;
          Blank3        : INTEGER;
          Blank4        : INTEGER;
          Blank5        : INTEGER;
          FullEdit      : BOOLEAN;
          Blank7        : BOOLEAN;
          Blank8        : BOOLEAN;
          Blank9        : BOOLEAN;
          Blank10       : BOOLEAN;
          Blank11       : REAL;
          Blank12       : REAL;
          Blank13       : REAL;
       END;

       MessageRecord  = RECORD
          Deleted     : BOOLEAN;
          Locked      : BOOLEAN;
          Date        : STRING;
          Time        : STRING[7];
          Title       : STRING[28];
          PersonTo    : STRING[25];
          From        : STRING[25];
          Number      : LONGINT;
          StartBlock  : INTEGER;
          TotalBlocks : INTEGER;
          Alais       : STRING[25];
          AlaisTo     : STRING[25];
          Reference   : LONGINT;
       END;

       hashed_record = RECORD
          recordnumber : INTEGER;
          name         : INTEGER;
       END;

       bulletin_record = RECORD
          name     : STRING[50];
          filename : STRING[30];
       END;


       d_k_type = RECORD
          level : BYTE;
          k     : INTEGER;
       END;

       Config_Record = RECORD
          Caller_Number  : REAL;
          Port_Num       : BYTE;
          Init_Str       : STRING [25];
          Init_Delay     : INTEGER;
          HangupStr      : STRING [80];
          Autobaud       : BOOLEAN;
          On_300         : STRING [20];
          On_1200        : STRING [20];
          On_2400        : STRING [20];
          Locked         : BOOLEAN;
          LockedSpeed    : LONGINT;

          Accept_New     : BOOLEAN;
          Timer_On       : BOOLEAN;

          Sysopname      : STRING [40];
          SysopName2     : STRING [40];
          SysopName3     : STRING [40];
          Sysop_Pw       : STRING [8];
          SystemName     : STRING [40];
          Miscpath       : STRING [50];
          Userpath       : STRING [50];
          Unvallevel     : BYTE;
          Vallevel       : BYTE;
          Sysoplevel     : BYTE;
          LocalLockPSW   : STRING [8];
          HiAccessPSW    : STRING [8];

          Bell_On        : BOOLEAN;
          B_color        : BYTE;
          W_color        : BYTE;
          F_color        : BYTE;

          D_level1       : BYTE;
          D_level2       : BYTE;
          D_noa          : BYTE;
          D_K            : ARRAY [1..4] OF BYTE;

          To_Prompt      : BOOLEAN;
          Show_Linenum   : BOOLEAN;
          Ext_chars      : BOOLEAN;

          promptSTR      : STRING [50];
          ChatIn         : STRING [80];
          ChatOut        : STRING [80];
          ChatCall1      : STRING [80];
          AfterChat      : STRING [80];
          TooManyChat    : STRING [80];
          ChatLimit      : WORD;
          LastCaller     : STRING [40];
          OneLiner       : STRING [80];
          LeftBy         : STRING [20];
          UpNum          : BYTE;
          BusyOnLocal    : BOOLEAN;
          Liners         : BOOLEAN;
          Color          : BOOLEAN;
          EditPath       : STRING [80];
          FullScreen     : BOOLEAN;
          TopTen         : ARRAY [1..10] of STRING [40];
          TopBytes       : ARRAY [1..10] of LongINT;
       END;

       speed_type = (slow, fast, very_fast, locked);



    CONST
           RColor      :   ARRAY [1..14] of String[2] =
                                                 ('R',
                                                 'G',
                                                 'Y',
                                                 'B',
                                                 'M',
                                                 'C',
                                                 'W',
                                                 'R2',
                                                 'G2',
                                                 'Y2',
                                                 'B2',
                                                 'M2',
                                                 'C2',
                                                 'W2');
  VAR
       Config            : Config_Record;
       FileRecord        : FileAreaRecord;
       CurFile           : File OF FileAreaRecord;
       Config_File       : FILE OF Config_Record;
       ZipReading        : BOOLEAN;
       Current_Speed     : Speed_type;
       p_min, p_max      : INTEGER;
       door_ok           : BOOLEAN;
       WindowOn          : BOOLEAN;
       ed_ing,ed_saved   : BOOLEAN;
       read_mode         : BOOLEAN;
       importing         : BOOLEAN;
       Alrm              : BOOLEAN;
       imp_file          : TEXT;
       ConfigOnBoot      : BOOLEAN;
       DOS_error_level   : BYTE;
       door_num          : INTEGER;
       p_cmd             : STRING[255];
                                  {all for Parser}
       p_abort           : BOOLEAN;
       new_user_on       : BOOLEAN;
       drive_space       : ARRAY [1..26] OF REAL;
       drive_total_avail : ARRAY [1..26] OF REAL;
       d_k               : ARRAY [1..4] OF d_k_type;
       CNum              : INTEGER;
       commands          : ARRAY [1..10] OF STRING [255];
       CapFile           : TEXT;
       Index             : INTEGER;
       capturing         : BOOLEAN;
       MenuChoices       : ARRAY [1..150] OF STRING [5];
       messagetext       : ARRAY [1..6528] OF BYTE;
       DoorSpeed         : STRING [4];
       MaxMainMenu       : INTEGER;
       headerfile        : FILE OF MessageRecord;
       libfile           : FILE;
       userfile          : FILE OF UserRecord;
       messageheader     : MessageRecord;
       user              : UserRecord;
       tempuser          : UserRecord;
       userindex         : ARRAY[0..max_users_possible] OF hashed_record;
       mail_to_hash      : ARRAY[1..max_msgs_possible] OF INTEGER;
       boardpack         : ARRAY[0..max_boards_possible] OF board_type;
       FileResultCode    : INTEGER;
       SpaceLeft         : REAL;
       SpaceTotal        : REAL;
       maxusers          : INTEGER;
       maxboards         : INTEGER;
       userindex_pos     : INTEGER;
       usersdeleted      : INTEGER;
       LogOnDate         : date_type;    {converted date}
       LogOnTime         : time_type;    {converted time}
       LogOffDate        : date_type;
       logOffTime        : time_type;
       logged_on         : BOOLEAN;
       log_file_on       : BOOLEAN;
       ChatTimes         : INTEGER;
       GoingForward      : BOOLEAN;       {used for direction of read}
       MainSelection     : STRING[80];    {used for main menu}
       ScanMode          : BOOLEAN;       {used for option of main menu}
       MaxLines          : INTEGER;
       MessBuff          : ARRAY [1..80] OF STRING[80];
       composing         : BOOLEAN;
       MaxLinesEntered   : INTEGER;
       SaveMsg           : BOOLEAN;
       AbortMsg          : BOOLEAN;
       QuoteMsg          : BOOLEAN;
       ExtChars          : BOOLEAN;
       MsgAreaNumber     : INTEGER;
       globalfilename    : STRING [13];
       globalblock       : INTEGER;
       PrivateBBS        : BOOLEAN;
       maxbaudrate       : INTEGER;
       DoorMin           : BYTE;
       DoorHour          : BYTE;
       pagelength        : INTEGER;
       MoreOn            : BOOLEAN;

       dr_1                      : STRING [2];
       dr_2                      : STRING [3];    {stuff to show disk space}
       dr_3                      : STRING [3];
       max_usertxt, max_readtxt  : INTEGER;




 {I/O variables below}
       NotInit           : BOOLEAN;
       lastcmd           : STRING[255];
                                   {used for ^R}
       oldinput          : STRING[255];
                                   {used for ^a and ^f and ^t}
       level             : INTEGER;
       term_width        : INTEGER;
       sysopavail        : BOOLEAN;
       going_busy        : BOOLEAN;
       beep_when_off     : BOOLEAN;
       auto_log_on       : BOOLEAN;
       busied            : BOOLEAN;
       user_waiting      : STRING[25];
       answering         : BOOLEAN;
       exit_program      : BOOLEAN;
       connect_mode      : (waiting, remote, local);
       user_chat_enabled : BOOLEAN;
       chatting          : BOOLEAN;
       BREAK             : BOOLEAN;
       break_enabled     : BOOLEAN;
       current_line      : STRING [80];
       wrap_save         : STRING [80];
       wrap              : BOOLEAN;
       done_chatting     : BOOLEAN;
       there_triggered   : BOOLEAN;
       sysoplvl          : INTEGER;
       silence           : BOOLEAN;
       yelling           : BOOLEAN;
       ctrl_s            : BOOLEAN;
       ctrl_c            : BOOLEAN;
       ctrl_k            : BOOLEAN;
       next_key          : BOOLEAN;
       flow_control      : BOOLEAN;
       anykey            : BOOLEAN;
       chat_key          : BOOLEAN;
       keyboard          : BOOLEAN;

       inactive          : INTEGER;
       inactive_warned   : BOOLEAN;
       timecheck         : BOOLEAN;
       time_on           : INTEGER;
       time_logged       : INTEGER;
       time_limit        : INTEGER;
       logon_time_limit  : INTEGER;
       logon_warn_time   : INTEGER;
       normal_warn_time  : INTEGER;
       inactive_time     : INTEGER;
       inactive_warn_time: INTEGER;
       warning_time      : INTEGER;
       min_tick          : INTEGER;
       DoorName          : STRING[80];
       OldColor          : INTEGER;
       MaxEvents         : BYTE;


 IMPLEMENTATION
 BEGIN
 END.  {UNIT}
